/*
 * Parameter.java
 *
 * Created on April 5, 2007, 1:42 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package net.sf.sql2java.common.parameters;

import java.util.regex.Matcher;
import java.util.regex.Pattern;
import net.sf.sql2java.utils.StringUtils;
import org.apache.log4j.Logger;

/**
 *
 * @author dge2
 */
public class Modifier {
    public static final Logger LOGGER = Logger.getLogger(Modifier.class);
    public static final String PREFIX = "\\?\\{";
    public static final String SUFFIX = "\\}";
    
// -- Constructors ------------------------------------------------------------
    
    public Modifier() { }

// -- Matching And Replacing --------------------------------------------------
    
    public String replace(String toCheck) {
        Pattern pattern = Pattern.compile(parameterize(), Pattern.CASE_INSENSITIVE);
        
        Matcher matcher = pattern.matcher(toCheck);
        
        while (matcher.find()) {
            // -- get the match
            String found = matcher.group();
            
            // -- create the replacement
            String replacement = found.substring(2, found.indexOf("@"));
            
            // -- Lets modify the result
            Pattern p = Pattern.compile("(\\@.{2})", Pattern.CASE_INSENSITIVE);
            Matcher m = p.matcher(found);
            
            while (m.find()) {
                String modifier = m.group();
                
                if (modifier.equalsIgnoreCase("@lc"))       // lowercase
                    replacement = replacement.toLowerCase();
                else if (modifier.equalsIgnoreCase("@uc"))  // uppercase
                    replacement = replacement.toUpperCase();
                else if (modifier.equalsIgnoreCase("@ca"))  // capitalize
                    replacement = StringUtils.capitalize(replacement);
                else if (modifier.equalsIgnoreCase("@dc"))  // decapitalize
                    replacement = StringUtils.decapitalize(replacement);
            }
            
            // -- reinject the result
            toCheck = toCheck.replaceFirst(parameterize(replacement), replacement);
        }
        
        // -- return our result
        return toCheck;
    }
    
    private String parameterize() {
        return "(" + PREFIX + ")(([^?|{]*)(\\@.{2})*)(" + SUFFIX + ")";
    }
    
    private String parameterize(String content) {
        return "(" + PREFIX + ")(((?i)" + content + ")(\\@.{2})*)(" + SUFFIX + ")";
    }
}
