/*
 * Parameter.java
 *
 * Created on April 5, 2007, 1:42 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package net.sf.sql2java.common.parameters;

import java.util.regex.Matcher;
import java.util.regex.Pattern;
import net.sf.sql2java.utils.StringUtils;
import org.apache.log4j.Logger;

/**
 *
 * @author dge2
 */
public class Parameter {
    public static final Logger LOGGER = Logger.getLogger(Parameter.class);
    public static final String PREFIX = ":\\{";
    public static final String SUFFIX = "\\}";
    
    private String name;
    private String value;
    
// -- Constructors ------------------------------------------------------------
    
    public Parameter(String name, String value) {
        this.name = name;
        this.value = value;
    }

// -- Matching And Replacing --------------------------------------------------
    
    public String replace(String toCheck) {
        Pattern pattern = Pattern.compile(parameterize(getName()), Pattern.CASE_INSENSITIVE);
        
        Matcher matcher = pattern.matcher(toCheck);
        
        while (matcher.find()) {
            // -- Create the replacement
            String replacement = "";
            
            // -- get the match
            String found = matcher.group();
            
            // -- Lets handle the found parameter
            replacement = getValue();
            
            // -- Lets modify the result
            Pattern p = Pattern.compile("(\\@.{2})", Pattern.CASE_INSENSITIVE);
            Matcher m = p.matcher(found);
            
            while (m.find()) {
                String modifier = m.group();
                
                if (modifier.equalsIgnoreCase("@lc"))
                    replacement = replacement.toLowerCase();
                else if (modifier.equalsIgnoreCase("@uc"))
                    replacement = replacement.toUpperCase();
                else if (modifier.equalsIgnoreCase("@ca"))
                    replacement = StringUtils.capitalize(replacement);
                else if (modifier.equalsIgnoreCase("@dc"))
                    replacement = StringUtils.decapitalize(replacement);
            }
            
            // -- reinject the result
            toCheck = toCheck.replaceFirst(parameterize(getName()), replacement);
        }
        
        // -- return our result
        return toCheck;
    }
    
    private String parameterize(String content) {
        return PREFIX + "((?i)" + content + ")(\\@.{2})*" + SUFFIX;
    }
    
// -- Getters -----------------------------------------------------------------

    /**
     * Gets the name of this parameter
     * 
     * @return 
     */
    public String getName() {
        return name;
    }
    
    public String getValue() {
        return value;
    }

// -- Setters -----------------------------------------------------------------
    
    public void setName(String name) {
        this.name = name;
    }

    public void setValue(String value) {
        this.value = value;
    }
}
