package net.sf.sql2java.common.parameters.handlers;

public interface ParameterHandler {

	/**
	 * What to do when a parameter has been found.
	 * <p>
	 * Once a parameter inside the <code>PString</code> has been found, this
	 * method will be called. The <code>PString</code> content will be provided
	 * as an attribute to this method. This method is responsible for replacing
	 * the parameter inside the content, if that is what this method needs to 
	 * do. In the end, the new content must be returned.
	 * 
	 * @param content	The content in which the parameter was found
	 * @param parameter	The parameter which has been found inside the content
	 * @return	The content with modifications, if there were any.
	 */
	public String onParameter(String content, String parameter);
	
}
