package net.sf.sql2java.data;

public class MapPointer extends Pointer {
	public static final String START_SEPARATOR 	= "(";
	public static final String STOP_SEPARATOR 	= ")";
	public static final String FORMAT = "%s" + START_SEPARATOR + "%s" + STOP_SEPARATOR;
	private String id;
	
// -- Constructors ------------------------------------------------------------
	
	public MapPointer(String property, String id) {
		super(property);
		this.id = id;
	}
	
// -- Creation ----------------------------------------------------------------
	
	public static MapPointer createPointer(String fullname) {
		// -- create the result
		MapPointer result = null;
		
		// -- get the index of the separator
		int index = fullname.indexOf(START_SEPARATOR);
		
		// -- check if the index is valid
		if (index < 1) return null;
		if (index > fullname.length() - 2) return null;
		
		// -- the first part will be the name, while the second part will be
		// -- the property
		String property = fullname.substring(0, index);
		String id = fullname.substring(index + 1, fullname.length() - 1);
		
		// -- create the result
		result = new MapPointer(property, id);
		
		// -- return the result
		return result;
	}
	
// -- Convertors --------------------------------------------------------------
	
	public String toString() {
		return super.name + START_SEPARATOR + id + STOP_SEPARATOR;
	}

// -- Comparison --------------------------------------------------------------
	
	public boolean equals(Object obj) {
		if (obj == null) return false;
		
		if (obj instanceof String) {
			return toString().equals((String) obj);
		} else if (obj instanceof MapPointer) {
			MapPointer p = (MapPointer) obj;
			
			if (! super.equals(p)) return false;
			if (! (p.getId().equals(id))) return false;
			
			return true;
		} else
			return false;
	}
	
// -- Getters -----------------------------------------------------------------
	
	public String getId() {
		return id;
	}
}
