package net.sf.sql2java.fetching.sql.link;

import net.sf.sql2java.data.holders.Column;

public class OneToManyLink implements DatabaseLink {
	private Column primaryOne;
	private Column secondaryMany;

// -- Constructors ------------------------------------------------------------
	
	public OneToManyLink() {}
	
	public OneToManyLink(Column primaryOne, Column secondaryMany) {
		this.primaryOne = primaryOne;    
		this.secondaryMany = secondaryMany;
	}
	
// -- Conversion --------------------------------------------------------------
	
	@Override
	public String toString() {
		return String.format(
				"[%s] -> [%s]*", 
				primaryOne.getFullName(), 
				secondaryMany.getFullName()
		);
	}
	
// -- Getters -----------------------------------------------------------------
	
	public Column getPrimaryOne() {
		return primaryOne;
	}
	
	public Column getSecondaryMany() {
		return secondaryMany;
	}
	
// -- Setters -----------------------------------------------------------------
	
	public void setPrimaryOne(Column primaryOne) {
		this.primaryOne = primaryOne;
	}
	
	public void setSecondaryMany(Column secondaryMany) {
		this.secondaryMany = secondaryMany;
	}
}
