package net.sf.sql2java.fetching.sql.link;

import net.sf.sql2java.data.holders.Column;

public class OneToOneLink implements DatabaseLink {
	private Column primaryOne;
	private Column secondaryOne;
	
// -- Constructors ------------------------------------------------------------
	
	public OneToOneLink() {}
	
	public OneToOneLink(Column primaryOne, Column secondaryOne) {
		this.primaryOne = primaryOne;
		this.secondaryOne = secondaryOne;
	}
	
// -- Conversion --------------------------------------------------------------
	
	@Override
	public String toString() {
		return String.format(
				"[%s] - [%s]", 
				primaryOne.getFullName(), 
				secondaryOne.getFullName()
		);
	}
	
// -- Getters -----------------------------------------------------------------

	public Column getPrimaryOne() {
		return primaryOne;
	}
	
	public Column getSecondaryOne() {
		return secondaryOne;
	}
	
// -- Setters -----------------------------------------------------------------
	
	public void setPrimaryOne(Column primaryOne) {
		this.primaryOne = primaryOne;
	}

	public void setSecondaryOne(Column secondaryOne) {
		this.secondaryOne = secondaryOne;
	}
}
