/*
 * Script.java
 *
 * Created on 15 maart 2007, 13:59
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package net.sf.sql2java.generator.scripting;

import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;

import net.sf.sql2java.packages.TemplatePack;

/**
 *
 * @author annba
 */
public class Script {
    private TemplatePack templatePack;
    private String name;
    private String resource;
    private String content;
    private String engineType;
    private ScriptEngine engine;
    
// -- Constructors ------------------------------------------------------------
    
    public Script() {
        this("", "", "");
    }
    
    public Script(String engineType, String name, String resource) {
        this.engineType = engineType;
        this.name = name;
        this.resource = resource;
    }
    
// -- Conversions -------------------------------------------------------------
    
    public String toString() {
        return name + " - [" + resource + "]";
    }
    
// -- Getters -----------------------------------------------------------------

    public TemplatePack getTemplatePack() {
        return templatePack;
    }
    
    public String getName() {
        return name;
    }
    
    public String getResource() {
        return resource;
    }
    
    public String getContent() {
        return content;
    }

    public String getEngineType() {
        return engineType;
    }
    
    public ScriptEngine getEngine() {
        if (engine == null)
            engine = (new ScriptEngineManager()).getEngineByName(engineType);
        
        return engine;
    }

// -- Setters -----------------------------------------------------------------

    public void setTemplatePack(TemplatePack templatePack) {
        this.templatePack = templatePack;
    }
    
    public void setName(String name) {
        this.name = name;
    }
    
    public void setResource(String resource) {
        this.resource = resource;
    }

    public void setContent(String content) {
        this.content = content;
    }
    
    public void setEngineType(String engineType) {
        this.engineType = engineType;
    }
}
