/*
 * SimpleGeneratedCodeWriter.java
 *
 * Created on April 2, 2007, 3:34 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package net.sf.sql2java.generator.writer;

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;

/**
 *
 * @author dge2
 */
public class SimpleCodeWriter extends CodeWriter {
    private String targetDirectory;

// -- Constructors ------------------------------------------------------------
    
    public SimpleCodeWriter(String targetDirectory) {
        this.targetDirectory = targetDirectory;
    }

// -- Write the parsed template to the file -----------------------------------
    
    public void write(String path, String content) throws Exception {
        // -- we need to add the target directory to the actual path
        path = appendTargetDirectory(path);
        
        // -- create a file for the path
        File file = new File(path);

        // -- create all the directories
        (new File(file.getParent())).mkdirs();
        
        // -- wrap the file into a writer so we can put data in it
        PrintWriter writer = new PrintWriter(new OutputStreamWriter(new FileOutputStream(file)));

        // -- write our content to the file
        writer.write(content);
        writer.flush();
        writer.close();
    }
    
// -- Helpers -----------------------------------------------------------------
    
    private String appendTargetDirectory(String path) {
        if (! targetDirectory.endsWith("/"))
            targetDirectory += "/";
        
        return targetDirectory + path;
    }
}
